<?php

namespace Tewst\Tewst\Http\Controllers;

use App\Http\Controllers\PublicController as CMSPublicController;
use Tewst\Tewst\Interfaces\TestRepositoryInterface;

class TestPublicController extends CMSPublicController
{
    /**
     * Constructor.
     *
     * @param type \Tewst\Test\Interfaces\TestRepositoryInterface $test
     *
     * @return type
     */
    public function __construct(TestRepositoryInterface $test)
    {
        $this->repository = $test;
        parent::__construct();
    }

    /**
     * Show test's list.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function index()
    {
        $tests = $this->repository->scopeQuery(function($query){
            return $query->orderBy('id','DESC');
        })->paginate();

        return $this->theme->of('tewst::public.test.index', compact('tests'))->render();
    }

    /**
     * Show test.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function show($slug)
    {
        $test = $this->repository->scopeQuery(function($query) use ($slug) {
            return $query->orderBy('id','DESC')
                         ->where('slug', $slug);
        })->first(['*']);

        return $this->theme->of('tewst::public.test.show', compact('test'))->render();
    }
}
